architecture bla_architecture of blabla is

type state_type is (eins, zwei, drei, ...);
signal current_state, next_state: state_type; 

begin  -- bla_architecture

	CONTROL: process(current_state, eins, zwei, ...)
	begin
		case current_state is
			when eins => if (input_1 = '1') then
						     next_state <= zwei;
						 elsif (...) then
						     next_state <= drei;
						 else
					    	 next_state <= eins;
						 end if;
					 
			when zwei => ...
		
			when others => next_state <= eins;
		end case;
	end process;

	SYNCH: process(clk, reset)
	begin
		if (reset = '0') then  -- low-active
			current_state <= eins;
		elsif (clk'event and clk='1')  -- rising flank
			current_state <= next_state;
		end if;
	end process;
	
end bla_architecture;

